/*+ FlashLoaderDlg.h
 *
 ******************************************************************************
 *
 *                        Trimble Navigation Limited
 *                           645 North Mary Avenue
 *                              P.O. Box 3642
 *                         Sunnyvale, CA 94088-3642
 *
 ******************************************************************************
 *
 *    Copyright  2005 Trimble Navigation Ltd.
 *    All Rights Reserved
 *
 ******************************************************************************
 *
 * Description:
 *    Interface for the CFlashLoaderDlg class.
 *            
 * Revision History:
 *    09-22-2005    Mike Priven
 *                  Cleaned up and adapted for outside distribution.
 *
 *    xx-xx-2001    Sean Zhi
 *                  Original
 *
 * Notes:
 *
-*/

#ifndef FLASH_LOADER_DLG_H
#define FLASH_LOADER_DLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/*---------------------------------------------------------------------------*\
 |                      C L A S S   D E F I N I T I O N
\*---------------------------------------------------------------------------*/
class CFlashLoaderDlg : public CDialog
{

public: //==== P U B L I C   M E T H O D S ===================================/
    
    CFlashLoaderDlg(CWnd* pParent = NULL);	// standard constructor
    
    void SetPortParams(CString strParas);
    void SendStr(char* str, short len);
    void MonStateSet(int state);
    void MonStateCheck(int state, int msecs, char retries);
    void TermFlashLoadingThd();
    
    
public: //==== P U B L I C   M E M B E R   V A R I A B L E S =================/
    
    //{{AFX_DATA(CFlashLoaderDlg)
    enum { IDD = IDD_FLASHLOADER_DIALOG };
    CProgressCtrl m_progress;
    CString	      m_str_filename;
    //}}AFX_DATA
    
    int           m_int_romType;
    CString       m_strFwBaseAddr;
    FILE          *m_romfile;
    HICON         m_hIcon;
    HANDLE        m_flashLoadingThread;
    BOOL          m_loading_started;
    BOOL          m_bool_port_selected[NUM_PORTS];
    BOOL          m_commctrl_created[NUM_PORTS];
    CMSComm       m_commctrl[NUM_PORTS];
    CButton       m_checkboxs[NUM_PORTS];
    CEdit	      m_edit_status[NUM_PORTS];
    int           m_int_mon_state[NUM_PORTS];
    unsigned char m_memBuffer[ROM_BUFFER_SIZE];
    unsigned char m_memBufferDemon[DEMON_BUFFER_SIZE];
    
protected: //==== P R O T E C T E D   M E T H O D S ==========================/
    
    //{{AFX_VIRTUAL(CFlashLoaderDlg)
    virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
    //}}AFX_VIRTUAL
    
    //{{AFX_MSG(CFlashLoaderDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
    afx_msg void OnDestroy();
    afx_msg void OnPaint();
    afx_msg HCURSOR OnQueryDragIcon();
    afx_msg void OnCheck1();
    afx_msg void OnCheck2();
    afx_msg void OnCheck3();
    afx_msg void OnCheck4();
    afx_msg void OnCheck5();
    afx_msg void OnCheck6();
    afx_msg void OnCheck7();
    afx_msg void OnCheck8();
    afx_msg void OnCheck9();
    afx_msg void OnCheck10();
    afx_msg void OnCheck11();
    afx_msg void OnCheck12();
    afx_msg void OnCheck13();
    afx_msg void OnCheck14();
    afx_msg void OnCheck15();
    afx_msg void OnCheck16();
    afx_msg void OnStart();
    afx_msg void OnAbout();
    afx_msg void OnFileChooser();
    virtual void OnCancel();
    afx_msg void OnSettings();
    afx_msg void OnClose();
    //}}AFX_MSG
    afx_msg void OnCommEvent_1();
    afx_msg void OnCommEvent_2();
    afx_msg void OnCommEvent_3();
    afx_msg void OnCommEvent_4();
    afx_msg void OnCommEvent_5();
    afx_msg void OnCommEvent_6();
    afx_msg void OnCommEvent_7();
    afx_msg void OnCommEvent_8();
    afx_msg void OnCommEvent_9();
    afx_msg void OnCommEvent_10();
    afx_msg void OnCommEvent_11();
    afx_msg void OnCommEvent_12();
    afx_msg void OnCommEvent_13();
    afx_msg void OnCommEvent_14();
    afx_msg void OnCommEvent_15();
    afx_msg void OnCommEvent_16();
    
    DECLARE_EVENTSINK_MAP()
        DECLARE_MESSAGE_MAP()
        
        
private: //==== P R I V A T E   M E T H O D S ================================/
    
    void OnCommEventHandler  (int portNum);
    void OnCheckHandler      (int portNum);
    void ProcessReceivedData (int portNum);
    bool OpenRomFile         ();
    
};

#endif // FLASH_LOADER_DLG_H
